require 'f5/icontrol'
require 'base64'
require_relative './libraries/vip'
require_relative './libraries/irule'

class Main < ChefF5::VIP
  def initialize
    @api = F5::Icontrol::API.new(
      nil,
      host: 'lv1stgfelb.dm.nfl.com',
      username: 'cusick',
      password: Base64.decode64('R29sZGVuYm93bF81Mg==')
    )
    @ProfileContextType = F5::Icontrol::LocalLB::ProfileContextType
    @ProfileType        = F5::Icontrol::LocalLB::ProfileType
    @EnabledStatus      = F5::Icontrol::LocalLB::EnabledStatus
    @EnabledState       = F5::Icontrol::Common::EnabledState
  end

  def api
    @api
  end

  def main

    vip= 'jsl-test-vip'
    # irules = {'cusick-test-2' => 0}
    # irules_changed = irules_changed?(vip, irules)
    # puts irules_changed.inspect
    # update_irules(vip, irules, *irules_changed)
    # puts api.LocalLB.VirtualServer.get_profile(virtual_servers: {item: [with_partition(vip)]})[:item][:item]
    remove_http_profile vip, with_partition('http-access')
    set_http_profile(vip, 'http')
    puts api.LocalLB.VirtualServer.get_profile(virtual_servers: {item: [with_partition(vip)]})[:item][:item]
  end

end

class IRuleMaker < ChefF5::IRule
  def main

    name = 'cusick-test-2'
    defin = <<-EOL
# For hosts that serve both http but attached to http and https vips, 
# this lets them know if the request
# originally came in on https
when HTTP_REQUEST {
  HTTP::header insert HTTPS true
}
    EOL
    missing = is_missing?(name)
    puts missing
    create(name, defin) if missing
    # changed = definition_changed?(name, defin)
    # puts changed
    # update_definition(name, defin) if changed
    # destroy(name)
  end

  def initialize
    @api = F5::Icontrol::API.new(
      nil,
      host: 'lv1stgfelb.dm.nfl.com',
      username: 'cusick',
      password: Base64.decode64('R29sZGVuYm93bF81Mg==')
    )
  end

  def api
    @api
  end
end

# IRuleMaker.new.main
Main.new.main
